searchData={"items":[{"type":"module","title":"ExMustache","doc":"ExMustache is a fast mustache templating library for Elixir.\n\nExMustache supports everything except lambda from mustache spec.","ref":"ExMustache.html"},{"type":"function","title":"ExMustache.parse/2","doc":"Parse the binary and create template which can be used to render","ref":"ExMustache.html#parse/2"},{"type":"function","title":"Options - ExMustache.parse/2","doc":"* `:dir` - directory where partial templates are located.","ref":"ExMustache.html#parse/2-options"},{"type":"function","title":"ExMustache.render/2","doc":"Renders template by interpolating map data. Map keys *must* be string type.\n\nReturns [iodata](https://hexdocs.pm/elixir/IO.html#module-io-data).","ref":"ExMustache.html#render/2"},{"type":"type","title":"ExMustache.t/0","doc":"","ref":"ExMustache.html#t:t/0"},{"type":"exception","title":"ExMustache.Error","doc":"","ref":"ExMustache.Error.html"},{"type":"extras","title":"ExMustache","doc":"# ExMustache [![Hex.pm](https://img.shields.io/hexpm/v/ex_mustache.svg)](https://hex.pm/packages/ex_mustache)\n\nExMustache is fast mustache templating library for Elixir.\n\nExMustache supports everything except lambda from mustache spec. It is faster and uses lesser memory when compared to alternatives. ExMustache is a pure elixir implementation.","ref":"readme.html"},{"type":"extras","title":"Installation - ExMustache","doc":"```elixir\ndef deps do\n  [\n    {:ex_mustache, \"~> x.x.x\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - ExMustache","doc":"```elixir\n# Parse once\nmustache_template = \"Hello {{name}}\\n You have just won {{value}} dollars\"\ntemplate = ExMustache.parse(mustache_template)\n\n\n# Render multiple times\niodata = ExMustache.render(template, %{\"name\" => \"Chris\", \"value\" => 10000})\nIO.puts(iodata)\n\niodata = ExMustache.render(template, %{\"name\" => \"Bob\", \"value\" => 20000})\nIO.puts(iodata)\n```\n\nNote that `render/2` returns iodata, which an efficient data structure for IO. Most of the IO operation accepts iodata so we can pass the rendered content without converting it to a binary. If you need rendered content as string, `IO.iodata_to_binary/1` can be used. More about [iodata](https://hexdocs.pm/elixir/IO.html#module-io-data)","ref":"readme.html#usage"},{"type":"extras","title":"Performance - ExMustache","doc":"With my [*unscientific* benchmarking](https://github.com/akash-akya/ex_mustache/tree/master/bench), when compared to [bbmustache](https://github.com/soranoba/bbmustache) (which is already a fast implementation), ExMustache is from 5 to 2 times faster and use 20 to 2 times lesser memory for *redering*. You can check the results [here](https://github.com/akash-akya/ex_mustache/tree/master/bench/BENCHMARK.md). These numbers vary a lot depending on the template, so take these number with grain of salt and please benchmark for your usecase if you are concerned with the performance. Check benchmark script sample case. Worst case scenario it should be at least as good as bbmustache.\n\nSince ExMustache is optimized for rendering, parsing might use 4 to 2 times more memory compared to bbmustache.\n\nPartial templates should be avoided to get better performance.","ref":"readme.html#performance"}],"content_type":"text/markdown"}